﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Com.LuisPedroFonseca.ProCamera2D;


public class GlassListener : MonoBehaviour {
    Transform player,self;
    public float breakNote = 0.9f;
    public Animator animator;
    public GameObject glass, shards, particles;
    public float maxTime = 1f;
    public bool breaked;
    public float currentTime = 0;
    public float decreaseRate = 1f;
    public float increaseRate = 3f;

    public float destroyTime = 5;

    [Range(1,11)]
    public int targetNote;
	// Use this for initialization
	void Start () {
        player = GameObject.FindGameObjectWithTag("Player").GetComponent<Transform>();
        self = transform;
		particles.SetActive(true);
		particles.GetComponent<ParticleSystem>().Stop();
	}
	
	// Update is called once per frame
	void Update () {



        currentTime -= Time.deltaTime * decreaseRate;
        if (currentTime < 0) currentTime = 0;

        if(Vector3.Distance(self.position,player.position) < PlayerAreaOfEffect.radius)
        {
			if(VoiceManager.CurrentProgress(VoiceManager.noteIntValue, targetNote) == 1 && !breaked)particles.GetComponent<ParticleSystem>().Play();
			else if(particles.GetComponent<ParticleSystem>().isPlaying) particles.GetComponent<ParticleSystem>().Stop();

            animator.SetFloat("Blend", VoiceManager.CurrentProgress(VoiceManager.noteIntValue,targetNote));
            if (!breaked)
            {
                if (VoiceManager.CurrentProgress(VoiceManager.noteIntValue, targetNote) == 1)//(VoiceManager.dbValueStatic > 0 && VoiceManager.noteDynamic > (breakNote - 0.1f) && VoiceManager.noteDynamic < breakNote + 0.1f)
                {
                    currentTime += Time.deltaTime * increaseRate;
                    if (currentTime >= maxTime)
                    {
                        GetComponent<BoxCollider>().enabled = false;
                        glass.SetActive(false);
                        shards.SetActive(true);
                        breaked = true;
						particles.GetComponent<ParticleSystem>().Stop();

						ProCamera2DShake.Instance.ShakeUsingPreset("GlassBreak");

                        GetComponent<AudioSource>().pitch = 1 + Random.Range(-1, 1);
                        GetComponent<AudioSource>().Play();

                        foreach (Rigidbody shard in shards.transform.GetComponentsInChildren<Rigidbody>())
                        {
                            Vector3 randomVec = new Vector3(Random.Range(-1, 1), Random.Range(1, 2), Random.Range(-1, 1));
                            Vector3 randomVec2 = new Vector3(Random.Range(-1, 1), Random.Range(-1, 1), Random.Range(-1, 1));
                            shard.GetComponent<Rigidbody>().AddTorque(randomVec2 * 800);
                            shard.GetComponent<Rigidbody>().AddExplosionForce(400, shards.transform.position + Vector3.down * 2, 5);

                        }
                    }
                }
            }               
            else
                {
                    destroyTime -= Time.deltaTime;
                    if (destroyTime < 0)
                    {
                    gameObject.SetActive(false);
                        //foreach (GameObject shard in shards.transform.GetComponentsInChildren<GameObject>())
                        //{
                        //    Destroy(shard);
                        //}
                    }
                }

		} else {
			animator.SetFloat("Blend", 0);
			if(particles.GetComponent<ParticleSystem>().isPlaying) particles.GetComponent<ParticleSystem>().Stop();
		}


    }
}
