﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlatformMovement : MonoBehaviour {
    public Animator animator;
    public Transform player, parent;
    public Transform endPos,meshPos;
    [Range(0f, 1f)]
    public float progress;
    public Vector3 progressPos, startPosition;
    public float smoothness = 5f;
    public float currentZ, currentY;
    [Range(1, 11)]
    public int targetNote;

    
    public float decreaseRate = 1f;
    public float increaseRate = 3f;


    AudioSource audiosource;
    // Use this for initialization
    void Start () {
		player =GameObject.FindGameObjectWithTag("Player").GetComponent<Transform>();
        parent = transform;
        audiosource = GetComponent<AudioSource>();
    }
	
   
	// Update is called once per frame
	void Update () {
        //if 0 >>>>>> currentx = startpos.x
        //     >>>>>> currenty = startpos.y

        //if 1 >>>>>> currentx = endpos.x
        //     >>>>>> currenty = endpos.y 

        //

        

        if (Vector3.Distance(parent.position, player.position) < PlayerAreaOfEffect.radius)
        {
            
            // progress = VoiceManager.noteToProgress;
            progress = VoiceManager.CurrentProgress(VoiceManager.noteIntValue, targetNote);
            audiosource.volume = progress;
            animator.SetFloat("Blend", progress);
            currentZ = (endPos.localPosition.z * progress);
            currentY = (endPos.localPosition.y * progress);
            progressPos = new Vector3(meshPos.localPosition.x, currentY, currentZ);
            Debug.Log("PROGRESSO NEGATIVO " + progress);
            if(progress==1)                
                meshPos.localPosition = Vector3.Lerp(meshPos.localPosition, progressPos, smoothness * Time.deltaTime * increaseRate);
            else
                meshPos.localPosition = Vector3.Lerp(meshPos.localPosition, progressPos, smoothness * Time.deltaTime * decreaseRate);

            
		} else {
			animator.SetFloat("Blend", 0);
			audiosource.volume = 0;
			progressPos = new Vector3(meshPos.localPosition.x, 0, 0);
			meshPos.localPosition = Vector3.Lerp(meshPos.localPosition, progressPos, smoothness * Time.deltaTime * decreaseRate);
		}







    }
}
