﻿
using UnityEngine;

public class DefaultCompanionGroundFollowMovement : Movement
{
    public override void Initialize()
    {
    }

	public override void FixedTick()
	{	
		if (!settings.agent.isOnNavMesh)
			return;
		if (SceneController.instance.isFading) 
		{
			SceneTransition ();	
			settings.currentFollowPosition = new Vector3(settings.followTarget.position.x, settings.GroundHit.y, settings.followTarget.position.z);
		}
		
		if (!pawn.isDead) 
		{
			Move ();
		}
        UpateMovement();
    }

    public override void Move()
	{
        Distance();

        if (settings.agent.pathPending)
            return;
        settings.agent.SetDestination(settings.currentFollowPosition);
    }

    //FIX
    public virtual void Distance()
    {
        if (Vector3.Distance(pawn.parentRoot.position, settings.followTarget.position) > settings.startFollowDistance)
        {
            float tempStopDistance = Random.Range(settings.stopDistance / 1.5f, settings.stopDistance);
			settings.currentFollowPosition =
				settings.followTarget.position + (settings.followTarget.right * tempStopDistance * Random.Range (-2, 2)) + (settings.followTarget.forward * Random.Range (-2, -4));
               // settings.followTarget.InverseTransformVector(tempStopDistance * Random.Range(-1, 1), 0, Random.Range(3,5) * -1f);
        }
    }

    public override void UpateMovement()
    {
        settings.currentVelocity = settings.agent.velocity.magnitude;
        if (settings.Grounded)
        {
            if (settings.lastFrameVelocity <= settings.currentVelocity)
                pawn.characterAnimator.SetFloat("velocity", settings.agent.velocity.magnitude, .1f, Time.deltaTime);
            else
                pawn.characterAnimator.SetFloat("velocity", settings.currentVelocity);
        }
        else
        {
            pawn.characterAnimator.SetFloat("velocity", 0, .1f, Time.deltaTime);
		}

        settings.lastFrameVelocity = settings.currentVelocity;
    }
}
