﻿using System;
using UnityEngine;
using Zenject;

[Serializable]
public class Pawn : ScriptableObject
{
	[Inject]
    public Settings settings;

    [Serializable]
    public class Settings
    {
		public Transform parentRoot;
		public Animator characterAnimator;
		public GameObject meshRoot;
        [Header("Setup")]
		public GameObject characterPrefab;
		public RuntimeAnimatorController animatorController;
		public GameObject ragdoll;
        public bool isDead;

		public Settings(Settings settings)
		{
			characterPrefab = settings.characterPrefab;
			animatorController = settings.animatorController;
		}
    }
}
