﻿using UnityEngine;
using InControl;

public class PlayerInputHandler : PlayerInput
{
	public PlayerInputActions playerActions;  

    public PlayerInputHandler(PlayerInputState _inputState)
    {
        inputState = _inputState;
    }

    public override void Initialize()
	{
		playerActions = PlayerInputActions.CreateWithDefaultBindings();

		if (!Camera.main)
			return;
		mainCamera = Camera.main.transform;    
	}

    public override void Tick()
    {
        InputUpdate();
    }

    public override void InputUpdate()
	{
		if (!mainCamera)
			return;
		inputState.LocalMovementInput = new Vector3(playerActions.Move.X, 0, playerActions.Move.Y);
        Vector3 normalizedLocalMovementInput = inputState.LocalMovementInput.normalized;
        Vector3 cameraForward = Vector3.Scale(mainCamera.forward, new Vector3(1, 0, 1)).normalized;
        inputState.WorldMovementInput = normalizedLocalMovementInput.z * cameraForward + normalizedLocalMovementInput.x * mainCamera.right;
    }
}
