﻿using UnityEngine;
using System;

public enum DefaultPlayerMoveTypes { None, Default }

public class FieldInstaller : PawnInstaller
{
    [SerializeField]
    public Settings settings = null;
    
    public override void InstallBindings()
    {
        Install();
        BindInstances(settings);
    }

    public override void Install()
    {
        InstallPawn(settings);
		InstallMovement(settings);
		InstallInput(settings);
    }

    public virtual void InstallMovement(Settings _settings)
    {
        base.InstallMovement(_settings);
        switch (settings.moveType)
        {
            case DefaultPlayerMoveTypes.None:
                break;
            case DefaultPlayerMoveTypes.Default:
                Container.BindAllInterfacesAndSelf<IMovement>().To<DefaultGroundMovement>().AsSingle();
                break;
            default:
                break;
        }
    }

    public virtual void InstallInput(Settings _settings)
    {
        base.InstallInput(_settings);
    }

    public virtual void CopyPawnReferences(Settings _settings)
    {
        base.CopyPawnReferences(_settings);
    }

    public virtual void InstallPawn(Settings _settings)
    {
        CopyPawnReferences(settings);
        base.InstallPawn(settings);
    }

    public virtual void BindInstances(Settings _settings)
    {
        base.BindInstances(_settings);
    }

    [Serializable]
    new public class Settings : PawnInstaller.Settings
    {
        public DefaultPlayerMoveTypes moveType;
    }
}