﻿using UnityEngine;
using Zenject;
using System;

public class PawnInstaller : MonoInstaller
{
    public override void InstallBindings()
    {
        //Install();
        //BindInstances();
    }

    public virtual void Install()
    {

    }

    public virtual void InstallMovement(Settings settings)
    {

    }

    public virtual void InstallInput(Settings settings)
    {
        Container.BindAllInterfaces<IPlayerInput>().To<PlayerInputHandler>().AsSingle();
        Container.BindAllInterfacesAndSelf<PlayerInputState>().AsSingle();
    }

    public virtual void CopyPawnReferences(Settings settings)
    {
        settings.controller = ScriptableObject.CreateInstance<Field>();
        settings.controller.pawn = ScriptableObject.CreateInstance<Pawn>();
		settings.controller.pawn.settings = new Pawn.Settings(settings.controllerField.pawn.settings);
        settings.controller.movement = ScriptableObject.CreateInstance<Movement>();
		settings.controller.movement.settings = new Movement.Settings(settings.controllerField.movement.settings);

		settings.controller.pawn.settings.parentRoot = gameObject.transform; 
		settings.controller.pawn.settings.meshRoot = Container.InstantiatePrefab(settings.controller.pawn.settings.characterPrefab);
		settings.controller.pawn.settings.characterAnimator = settings.controller.pawn.settings.meshRoot.GetComponent<Animator> ();
		settings.controller.pawn.settings.characterAnimator.runtimeAnimatorController = settings.controller.pawn.settings.animatorController;

    }

    public virtual void InstallPawn(Settings settings)
    {
        Container.BindAllInterfacesAndSelf<Pawn>().AsSingle();
    }

    public virtual void BindInstances(Settings settings)
    {
        Container.BindInstance(settings.controller.pawn.settings);
        Container.BindInstance(settings.controller.movement.settings);
    }

    [Serializable]
    public class Settings
    {
        public Field controller;
        public Field controllerField;
    }
}