﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpikeBehaviour : MonoBehaviour {
    [Range(1, 11)]
    public int targetNote;
    public Animator animator;
    float progress;
    bool breaked;
    public GameObject shards,spike;
    public Transform player,self;
    public AudioClip[] clips;
	// Use this for initialization
	void Start () {
        // animator = GetComponent<Animator>();
        player = GameObject.FindGameObjectWithTag("Player").GetComponent<Transform>();
        self = transform;
	}
	
	// Update is called once per frame
	void Update () {



        if (Vector3.Distance(self.position, player.position) <= PlayerAreaOfEffect.radius)
        {
            progress = VoiceManager.CurrentProgress(VoiceManager.noteIntValue, targetNote);

            if (!breaked && progress == 1)
            {
                GetComponent<Spike>().enabled = true;
                GetComponent<AudioSource>().clip = clips[0];//.Play();
                GetComponent<AudioSource>().Play();
                breaked = true;
            }
            else
            {
                animator.SetFloat("Blend", progress);
            }

		} else {
			animator.SetFloat("Blend", 0);
		}




    }
    public void Shatter()
    {
        spike.SetActive(false);//GetComponent<MeshRenderer>().enabled = false;
        shards.SetActive(true);
        GetComponent<AudioSource>().clip = clips[1];//.Play();
        GetComponent<AudioSource>().Play();

        foreach (Rigidbody shard in shards.transform.GetComponentsInChildren<Rigidbody>())
        {
            Vector3 randomVec = new Vector3(Random.Range(-1, 1), Random.Range(1, 2), Random.Range(-1, 1));
            Vector3 randomVec2 = new Vector3(Random.Range(-1, 1), Random.Range(-1, 1), Random.Range(-1, 1));
            shard.GetComponent<Rigidbody>().AddTorque(randomVec2 * 800);
            shard.GetComponent<Rigidbody>().AddExplosionForce(400, shards.transform.position + Vector3.down * 2, 5);

        }
    }
}
