﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class VoiceControlGeneric : MonoBehaviour {
    
    public Transform player, self, target;
    public bool isScale;
    [Range(0f, 1f)]
    public float progress;

    public float smoothness = 5f;

    [Range(1, 11)]
    public int targetNote;
    public Vector3 targetVector,originalPos, originalScale;

    public float increaseRate = 3;
    public float decreaseRate = 1;

    void Start()
    {
        player = GameObject.FindGameObjectWithTag("Player").GetComponent<Transform>();
        self = transform;
        originalPos = target.localPosition;
        originalScale = target.localScale;
    }
    void Update()
    {
        progress = VoiceManager.CurrentProgress(VoiceManager.noteIntValue, targetNote);

        if (Vector3.Distance(self.position, player.position) < PlayerAreaOfEffect.radius*1.5f)
        {
           

            if (isScale)
            {
                if (progress == 1)
                    target.localScale = Vector3.Lerp(target.localScale, originalScale+targetVector * progress, smoothness * Time.deltaTime * increaseRate);
                else
                    target.localScale = Vector3.Lerp(target.localScale, originalScale+targetVector * progress, smoothness * Time.deltaTime * increaseRate);

            }
            else
            {
                if (progress == 1)
                    target.localPosition = Vector3.Lerp(target.localPosition, originalPos+ targetVector *progress, smoothness * Time.deltaTime * increaseRate);
                else
                    target.localPosition = Vector3.Lerp(target.localPosition, originalPos+targetVector * progress, smoothness * Time.deltaTime * increaseRate);

            }



        }
        else
        {
            if(isScale)
            target.localScale = Vector3.Lerp(target.localScale, originalScale, smoothness * Time.deltaTime * increaseRate);
            else
            target.localPosition = Vector3.Lerp(target.localPosition, originalPos, smoothness * Time.deltaTime * increaseRate);
        }







    }
}
